#include "../include/GV.h"
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <math.h>

#include <sys/io.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>

#include <pthread.h>

#include <termios.h>
#include <stdio.h>
#include <string.h>

#define DS_PORT "/dev/ttyS1"
#define BAU B19200

#define CN 6

static struct termios oldtio,newtio;

static int fd_dcom;

int retang;

void ini_ds(){

	char command[127];

	if((fd_dcom=open( DS_PORT , O_RDWR | O_NOCTTY ))<0){
			fprintf(stderr,"couldn't open fd_dcom \n");
			return;
	}printf("fd=%d\n",fd_dcom);

	fcntl(fd_dcom, F_SETFL, FASYNC);
	tcgetattr(fd_dcom,&oldtio);

	bzero(&newtio, sizeof(newtio));
	newtio.c_cflag = BAU | CS8 | CLOCAL | CREAD;
	newtio.c_iflag = IGNPAR;
	newtio.c_oflag = 0;
	newtio.c_lflag = 0;	//非カノニカル
	newtio.c_cc[VTIME]    = 0;	//キャラクタ間タイマ無効
	newtio.c_cc[VMIN]     = CN;	//6文字読み込むまでブロック
 
	tcflush(fd_dcom, TCIFLUSH);
	tcsetattr(fd_dcom,TCSANOW,&newtio);

	sprintf(command,"* DM FB @21 w47_74_51_41 \r\n");
	//待ち時間を01[HEX]*200マイクロ秒 DMモニター解除 出力１６進表記
	//I2Cアドレス　Gコマンド　レジスタアドレス指定　queryモード　Aコマンド

	write(fd_dcom,command,strlen(command));
	
	return;

}

static fd_set rfds;
static struct timeval tv;

int ds_get(){
	
	int i,result=0;
	
	char buf[127],command[50];
	char buf_temp;
	
	tcflush(fd_dcom, TCIFLUSH);

	sprintf(command,"s@21 r2p\r\n");
	
	write(fd_dcom,command,strlen(command));
	
	usleep(50000);
	
	read(fd_dcom,&buf,CN);
	
	for(i=0;i<4;i++){
	
		switch(i){
		
		case 0:
			buf_temp=buf[1];
			break;
		case 1:
			buf_temp=buf[2];
			break;
		case 2:
			buf_temp=buf[4];
			break;
		case 3:
			buf_temp=buf[5];
			break;
		
		}
		
		if(buf_temp>=48 && buf_temp<=57)result+=(buf_temp-48)*pow(16,3-i);
   else if(buf_temp>=97 && buf_temp<=102)result+=(buf_temp-87)*pow(16,3-i);
		else{
			fprintf(stderr,"number encord error\n");
			return 9999;
		}
		
		
	}
	
	result/=10;
	
	/*if(result>=0 && result<95)result*=0.947;
	else if(result>=95 && result<190)result=0.947*(result-90)+95;
	else if(result>=190 && result<264)result=0.952*(result-180)+190;*/

	retang=result;

	ds_conv();	

	return (retang);

}


#define DELAY_DS 50000

extern int ang;

void *ds_thread(){
	
	int temp,temp2,old=0,loop_cnt=0;
	
	ini_ds();
	usleep(DELAY_DS);
	
	ds_get();//なんか一回目はRAMに残った値を出力しちゃうみたいなんでとりあえずやっとく
	
	int stdang=ds_get();

	while(1){/*
		temp=ds_get();
		
		temp2=stdang-temp-360;
		
		if(temp2-old>180)loop_cnt--;
		else if(temp2-old<-180)loop_cnt++;
		
		ang=temp2+360*loop_cnt;
		
		old=temp2;*/
		
		temp=ds_get();
		
		printf("angle=%d\n",temp);
		
		usleep(DELAY_DS);
		
	
	}

}

