#ifndef __MG3_H__
#define __MG3_H__

#include <stdint.h>
/* movement paramter */
#define circle_radious 360	/* circle diameter of going arround a post */
/* USS measurment parmeter */
#define USS_MAX 150		/* POST distace maxmimum [cm]*/
#define USS_MIN 20 		/* POST distace minimum [cm]*/
#define MCENTER_USS3_DIS 138		/* Distance between MIRS center and USS3 */
#define MCENTER_USS12_DIS 120		/* Distance between MIRS center and USS1,2 */
#define USS12_DIFF  0		/* USS Diffrence = USS1 - USS2  */
#define USS_CORRECT -30 /* Difference of USS data from correct distance */
/* MOTOR measurement parameter */
//#define Kp 30
#define Kp 50
//#define Ki 5
#define Ki 3
#define W_RADIUS 57
#define G_RATIO 1.43
#define ENC_COUNT 360
#define VMAX 127
#define M_DELAY 1.2
#define PI 3.141592
#define MIRS_RADIUS 152
#define CIRCLE_RADIUS 350
#define MOTOR_CYCLE 100
#define t_par	(2*3.141592*W_RADIUS*G_RATIO/ENC_COUNT)

// tuning parameter 
#define POST_ANG_DIFF	-14 /* POST angle diffrence in post_search */
#define AROUND_ANG      360-10 /* Rotation Angle around post in post_circle */

struct ball{
	double dis;
	double deg;
};

typedef struct _MotorInfo{
	int fd;
	int kp;
	int ki;
	int send_dis;//[mm]
	int t;//[msec]
	int recv_dis;//[mm]
	int speed;//[m/s]
	uint16_t pwm;
	int32_t puls;
}MotorInfo;

struct target{
	double dis[10];
	double deg[10];
	int num[10];
};

MotorInfo ml;
MotorInfo mr;

pthread_mutex_t mutex_motor;
int mtask_flag;

#endif
