
#include "../include/GV.h"

void act_uss(){
	
		sensor.uss1=uss_get(1);
		sensor.uss2=uss_get(2);
		sensor.uss3=uss_get(3);
		
	}
	

void act_ds(){

	//sensor.ds=ds_get();

}


void act_DB(){

}

void act_siso(){

}

void act_step(){

}

void act_goal(){

}




//act_onoffはもうmirs自機の方でつくってある
//メモ→超音波センサーの値を平均する際、半分以上が20なら20にしたほうがいい
//メモ→各種微調整は実際走らせてから行う 現段階の憶測で行っても無意味と判断




/*******************************************************************************************
通路走行関数

mirs.process : 進行プロセス

*******************************************************************************************/
void act_normal(){
	
	switch(mirs.process){
		
		
	case 0://直進動作
		
		flag.forward=1;
		
		 	if(sensor.uss1>DIS_WALL+40)motor_forward(F_SPEED);
		else if(sensor.uss1>DIS_WALL+20)motor_forward(F_SPEED/2);
		else if(sensor.uss1>DIS_WALL+10)motor_forward(F_SPEED/3);
		else if(sensor.uss1>DIS_WALL)motor_forward(F_SPEED/6);
		else {
				motor_stop2();
				mirs.process=1;
		}
		
		break;
		
		
	case 1://回転動作の準備
		
			mirs.angle_old=mirs.angle_now;//ターン前の角度を保存
		
			if(sensor.uss2 <= DIS_WALL)mirs.process=2;
		else if(sensor.uss3 <= DIS_WALL)mirs.process=3;
		
		break;
		
		
	case 2://右回転動作
		
		flag.rotation_r=1;		

		if(turn_right(90.0))mirs.process=0;
		
		break;
		
		
	case 3://左回転動作
		
		flag.rotation_l=1;
		
		if(turn_left(90.0))mirs.process=0;
		
		break;
		
		
	default :
		fprintf(stderr,"mirs.processの値が不正です");
		exit(-1);
		
		break;
		
	}
}



/*******************************************************************************************
ロータリー通過関数

π/4円弧移動し、超音波センサーの値を読んで道を判別する

mirs.DBflag : 仕掛け前の通路なのか、仕掛けなのかを判別するフラグ
mirs.process : 進行プロセス

*******************************************************************************************/
void act_rota(){


	if(mirs.DBflag==1){//仕掛け前通路ならば

	   if(sensor.uss1<=DIS_WALL)
		if(sensor.uss2>DIS_WALL && sensor.uss3>DIS_WALL){
			motor_stop2();
			mirs.DBflag=2;
			return;
		}

		act_normal();
		return;

	}


	switch(mirs.process){

	
	case 0://回転動作の準備
		
		loop=0;
		delay=0;
		
		mirs.angle_old=mirs.angle_now;
		mirs.process=1;
		
		break;
	
	case 1://右回転動作
		
		flag.rotation_r=1;
	
		if(turn_right(90.0))mirs.process=2;
	
		break;
	
	
	case 2://旋回動作の準備
		
		mirs.angle_old=mirs.angle_now;
		mirs.process=3;

		break;
	
		
	case 3://旋回動作
		
		flag.circle_r=1;
		
		ang=mirs.angle_now-mirs.angle_old;
		
			 if(ang<85.0)motor_circle(C_SPEED,RADIUS);
		else if(ang<90.0-M_ERROR)motor_circle(C_SPEED/10,RADIUS);
		else if(ang<90.0+M_ERROR){
			motor_stop2();
			mirs.process=4;
		
		}
		
		break;
		
	
	case 4://道or壁の判断
		
		//メモ→現段階ではPI/2旋回したら超音波センサーの値を読み取るようにしてあるが
		//ロータリーエンコーダーが信用できない場合は、常に超音波センサーの値を監視したほうがよい
		
		loop++;
		
		if(sensor.uss2>=DIS_WALL)mirs.process=5;
		else{mirs.process=2;}//旋回動作へ戻る
		
		if(loop%4==0)mirs.process=2;//一周してしまったらまたループに戻る
		
		break;
	
	
	case 5://ロータリー脱出動作の準備(実質回転動作だけではあるが便宜上 case 1 とは分ける)
	
		loop=0;
		
		mirs.angle_old=mirs.angle_now;
		mirs.process=6;
		
		break;
		
		
	case 6://右回転動作

		flag.rotation_r=1;
	
		if(turn_right(90.0))mirs.process=99;
	
		break;
		
		
	case 99://脱出用直進
		
		delay++;
		
		motor_forward(F_SPEED/2);
		
		if(delay>=DELAY){//時間稼ぎのif文
			mirs.state=0;
			mirs.process=0;
		}
		
		break;
		
	default :
		fprintf(stderr,"mirs.processの値が不正です");
		exit(-1);
		
		break;
		
	}

}


/*******************************************************************************************
小部屋通過関数

各侵入方法(右端、中央、左端)によって、それぞれ別の行動をとる。

mirs.kosumo : 侵入してきた場所(右端=0,中央=1,左端=2)
mirs.DBflag : 仕掛け前の通路なのか、仕掛けなのかを判別するフラグ
mirs.process : 進行プロセス
iriguti : 小部屋の入口を出口と間違えないための変数

*******************************************************************************************/
void act_kosumo(){

	if(mirs.DBflag==1){//仕掛け前通路ならば

	   if(sensor.uss2>DIS_WALL || sensor.uss3>DIS_WALL)
		if(sensor.uss1>DIS_WALL){
			motor_stop2();
			mirs.DBflag=2;

			if(sensor.uss2<=DIS_WALL)mirs.kosumo=0;
		 else if(sensor.uss3<=DIS_WALL)mirs.kosumo=2;
		 else{mirs.kosumo=1;}//どっちも壁じゃなきゃ中央だわな

			return;
		}


		act_normal();
		return;

	}


	switch(mirs.process){

	case 0:

			if(mirs.kosumo==0){
				mirs.process=20;		
		}else if(mirs.kosumo==1){
				mirs.process=10;
		}else if(mirs.kosumo==2){
				mirs.process=30;
			}

		mirs.angle_old=mirs.angle_now;

		iriguti=0;
		delay=0;		

		break;


	case 10://中央から侵入した場合(右回転)

		flag.rotation_r=1;
	
		if(turn_right(90.0))mirs.process=11;
	
		break;


	case 11://ここで用いるアルゴリズムは、回転後、壁に一回出会ってから道を発見したら道と判断する
		  //そうしないと、回転後、小部屋の入口を道と判断してしまう。

		flag.forward=1;

		if(sensor.uss2<=DIS_WALL && iriguti==0)iriguti=1;

		if(sensor.uss2>DIS_WALL && iriguti==1){
				mirs.process=13;
				return;
			}
		
		 	if(sensor.uss1>DIS_WALL+40)motor_forward(F_SPEED);
		else if(sensor.uss1>DIS_WALL+20)motor_forward(F_SPEED/2);
		else if(sensor.uss1>DIS_WALL+10)motor_forward(F_SPEED/3);
		else if(sensor.uss1>DIS_WALL)motor_forward(F_SPEED/6);
		else {
				motor_stop2();
				mirs.process=12;
		}
		
		break;


	case 12://左回転動作
		
		flag.rotation_l=1;
		
		if(turn_left(90.0))mirs.process=11;
		
		break;


	case 13://出口に向かう回転(右回転)

		flag.rotation_r=1;
	
		if(turn_right(90.0))mirs.process=99;
	
		break;


	case 20://右端から侵入した場合

		flag.forward=1;

		if(sensor.uss2>DIS_WALL){
				mirs.process=22;
				return;
			}
		
		 	if(sensor.uss1>DIS_WALL+40)motor_forward(F_SPEED);
		else if(sensor.uss1>DIS_WALL+20)motor_forward(F_SPEED/2);
		else if(sensor.uss1>DIS_WALL+10)motor_forward(F_SPEED/3);
		else if(sensor.uss1>DIS_WALL)motor_forward(F_SPEED/6);
		else {
				motor_stop2();
				mirs.process=21;
		}
		
		break;


	case 21:

		flag.rotation_l=1;

		if(turn_left(90.0))mirs.process=20;

		break;

	case 22:

		flag.rotation_r=1;

		if(turn_right(90.0))mirs.process=99;

		break;


	case 30://右端から侵入した場合

		flag.forward=1;

		if(sensor.uss3>DIS_WALL){
				mirs.process=32;
				return;
			}
		
		 	if(sensor.uss1>DIS_WALL+40)motor_forward(F_SPEED);
		else if(sensor.uss1>DIS_WALL+20)motor_forward(F_SPEED/2);
		else if(sensor.uss1>DIS_WALL+10)motor_forward(F_SPEED/3);
		else if(sensor.uss1>DIS_WALL)motor_forward(F_SPEED/6);
		else {
				motor_stop2();
				mirs.process=31;
		}
		
		break;


	case 31:

		flag.rotation_r=1;

		if(turn_right(90.0))mirs.process=30;

		break;

	case 32:

		flag.rotation_l=1;

		if(turn_left(90.0))mirs.process=99;

		break;


	
	case 99://脱出用直進
		
		delay++;
		
		motor_forward(F_SPEED/2);
		
		if(delay>=DELAY){//時間稼ぎのif文
			mirs.state=0;
			mirs.process=0;
		}
		
		break;
		
	default :
		fprintf(stderr,"mirs.processの値が不正です");
		exit(-1);
		
		break;

		
	}

}



void act_ikidomari(){

	motor_stop2();

	switch(mirs.process){

	case 0:

		if(turn_right(180.0))mirs.process=1;

		break;

	case 1://通路走行動作+α(元の道に復帰するためのif文有)

		if(sensor.uss2>DIS_WALL || sensor.uss3>DIS_WALL)
			if(sensor.uss1>DIS_WALL){
				if(sensor.uss2>DIS_WALL)mirs.process=2;
			 else if(sensor.uss3>DIS_WALL)mirs.process=3;
			}

		act_normal();

		break;

	case 2:

		if(turn_right(90.0))mirs.process=99;

		break;

	case 3:

		if(turn_left(90.0))mirs.process=99;

		break;

	case 99://脱出用直進
		
		delay++;
		
		motor_forward(F_SPEED/2);
		
		if(delay>=DELAY){//時間稼ぎのif文(白線こえないとまずい)
			mirs.process=100;
		}
		
		break;

	case 100://最後の１８０度回転

		if(turn_right(180.0)){
				mirs.state=0;
				mirs.process=0;
			}

		break;
	

	default :
		fprintf(stderr,"mirs.processの値が不正です");
		exit(-1);
		
		break;

	}

}








