#include "../include/GV.h"
#include <string.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <time.h>
#include <stdio.h>

int main(void){
	
	ini();//初期設定関数
	ini_onoff_thread();//onoffセンサー監視スレッド
	ini_thread();//センサー&key監視スレッド

	double start,end;
	int fps;
	
	while(1){

		start=gettime();	

		memset(&flag,0,sizeof(flag));//flagが変わるごとにいちいち1を0にするのがめんどいから一気にやっちゃえと

		printf("mirs.state=%d\n",mirs.state);		

		//act_uss();//超音波センサー作動

		act_ds();//電子コンパス作動

		select_state();//現在状態判断関数		

		mirs.state=-1;

		switch(mirs.state){
			case -1://デバッグ用
				break;

			case 0://通路走行行動
				act_normal();
				break;
			
			case 9://白線発見後の例外動作
				break;
			
			case 10:
				act_DB();//DB読み取り行動
				break;
			
			case 20://ロータリー通過行動
				act_rota();
				break;
			
			case 30://小部屋通行行動
				act_kosumo();
				break;
			
			case 40://行き止まり回避行動
				act_ikidomari();
				break;
			
			case 50://シーソー判別・通過行動
				act_siso();
				break;
			
			case 60://ステップ判別・通過行動
				act_step();
				break;
			
			case 70://ゴール通過行動
				act_goal();
				break;
			
			default:
				fprintf(stderr,"mirs.stateの値が不正です\n");
				exit(-1);
				break;

		}

	end=gettime();

	fps=(int)(1.0/(end-start));
	
	printf("ts1=%c\t ts2=%c\t ws1=%c\t ws2=%c\n",sensor.ts1,sensor.ts2,sensor.ws1,sensor.ws2);

	printf("ws3=%c  irs=%c  ds=%c\n",sensor.ws3,sensor.irs,sensor.ds);
	printf("uss1=%d  uss2=%d  uss3=%d\n",sensor.uss1,sensor.uss2,sensor.uss3);

	printf("処理時間=%10.20lf sec\n",end-start);
	printf("fps=%d\n\n",fps);

	usleep(250000);

	}

return 0;

}

//メモ→メインループの最初と最後にmutexのロックとアンロックかけておけば、別処理でまわしてるので、
//	アンロックした瞬間に値が変化するといったこともできるかも
//メモ→特にuss系は、関数の中で別に格納変数用意して、値が変わっても問題ないようにするか、ロックかけないと
//	同じ条件式を便宜上複数回に渡って用いるときに、結果が変わっておかしな行動する可能性もある。	
