#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
//#include <termios.h>
#include <pthread.h>
//#include <sys/types.h>
//#include <sys/stat.h>
#include <fcntl.h>
#include "../include/func_extern.h"
#include "../include/mg3.h"
//#include "../main/control.h"
//#include "../main/pwm_enc.h"
#include "../include/motor.h"

extern int fd1, fd2;
extern pthread_t motor_task;
extern pthread_attr_t attr_motor;

int motor_thread(char sel,int dis_or_deg,int time){
	int s=0;
	int dt[2];

	mtask_flag=0;
	
	dt[0]=dis_or_deg; // distanece [mm]
	dt[1]=time; // time [msec]

	pthread_mutex_lock(&mutex_motor);
	motor_send_start_packet (fd1);
	motor_send_start_packet (fd2);
	pthread_mutex_unlock(&mutex_motor);
	if(sel == 's'){
		printf("t start\n");
		s=pthread_create(&motor_task, &attr_motor, motor_thread_straight, (void*)dt);
	}else if(sel == 'r'){
		s=pthread_create(&motor_task, &attr_motor, motor_thread_rotate, (void*)dt);
	}else if(sel == 'c'){
		s=pthread_create(&motor_task, &attr_motor, motor_thread_circle, (void*)dt);
	}else{
		printf("command_errer\n");
	}
	if( s != 0 ){ printf("motor_task create error\n"); }

	pthread_join(motor_task, NULL);

	pthread_mutex_lock(&mutex_motor);
	motor_send_stop_packet (fd1);
	motor_send_stop_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	pthread_mutex_unlock(&mutex_motor);

	return 0;
}
	
void *motor_thread_straight(void *arg){
	int c_left,c_right;
	int *cmd=(int*)arg;
	int dis,time;
	int speed_l, speed_r;
	int x_l,x_r;
	int dir=1; //direction flag
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	printf("thread in\n");
	dis=cmd[0];
	time=cmd[1];
	
	speed_l=(int)(100*dis/(t_par*time));
	speed_r=(int)(100*dis/(t_par*time));
	
	if(abs(speed_l) > VMAX){
		if(speed_l < 0){ v_l=VMAX; v_r=VMAX; }
		else{ v_l = -VMAX; v_r = -VMAX; }
	}else{
		v_l = (char)speed_l;
		v_r = (char)speed_r;
	}
	v_lm = v_l; v_rm = v_r;	
	if(v_l<0){
		dir=-1;
	}
	if(abs(v_l)<15){
		v_l=15*dir;
		v_r=15*dir;
	}

	pthread_mutex_lock(&mutex_motor);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	//printf("send start\n");
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);

	usleep(130*1000);

	printf("end\n");
	c_left=0; c_right=0;
	while(1){
		//pthread_testcancel();
		//printf("recv start\n");
		
		pthread_mutex_lock(&mutex_motor);
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		pthread_mutex_unlock(&mutex_motor);
		printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		printf("end\n");		
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		//printf("puls\tl = %d, r = %d\n", c_left, c_right);
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		//if(v_l <= 0 || v_r <= 0) break;

		if(abs(x_l-dis) > 50 || abs(x_r-dis) > 50){
			if(x_l - x_r > 10){
				v_lm=v_l-3; v_rm=v_r+3;
				pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				pthread_mutex_unlock(&mutex_motor);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else if(x_r - x_l > 10){
				pthread_mutex_lock(&mutex_motor);
				v_lm=v_l+3; v_rm=v_r-3;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
				pthread_mutex_unlock(&mutex_motor);
			}else{
				pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_l,Kp,Ki);
				motor_send_control_packet(fd2,v_r,Kp,Ki);
				pthread_mutex_unlock(&mutex_motor);
			}
		}

		if(abs(x_l-dis) < 50 && abs(x_r-dis) < 50){
			pthread_mutex_lock(&mutex_motor);
			motor_send_control_packet(fd1,10,Kp,Ki);
			motor_send_control_packet(fd2,10,Kp,Ki);
			pthread_mutex_unlock(&mutex_motor);
			while(1){
				printf("recv start\n");
				pthread_mutex_lock(&mutex_motor);
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				pthread_mutex_unlock(&mutex_motor);
				printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
				printf("end\n");		
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
				printf("puls\tl = %d, r = %d\n", c_left, c_right);
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);

				if(abs(x_l-dis) < 10 && abs(x_r-dis) < 10){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
					break;
				}
				if(abs(x_l-dis) < 20 && abs(x_r-dis) < 20){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,5*dir,Kp,Ki);
					motor_send_control_packet(fd2,5*dir,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
				}else if(abs(x_l-dis) < 20 || abs(x_r-dis) < 20){
					if(abs(x_l-dis) < 20){
						pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd1,5*dir,Kp,Ki);
						pthread_mutex_unlock(&mutex_motor);
					}else{
						pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd2,5*dir,Kp,Ki);
						pthread_mutex_unlock(&mutex_motor);
					}
				}

				if(abs(x_l) > abs(dis)+10 &&  abs(x_r) > abs(dis)+10){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,-7*dir,Kp,Ki);
					motor_send_control_packet(fd2,-7*dir,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
				}else if(abs(x_l) > abs(dis)+10 ||  abs(x_r) > abs(dis)+10){
					if(abs(x_l) > abs(dis)+10){
						pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd1,-7*dir,Kp,Ki);
						pthread_mutex_unlock(&mutex_motor);
					}else{
						pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd2,-7*dir,Kp,Ki);
						pthread_mutex_unlock(&mutex_motor);
					}

				}

				printf("roop end\n");
				usleep(130*1000);
			}
			break;
		}
		usleep(130*1000);
	}
	
	pthread_mutex_lock(&mutex_motor);
	motor_send_control_packet(fd1,0,Kp,Ki);
	motor_send_control_packet(fd2,0,Kp,Ki);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	pthread_mutex_unlock(&mutex_motor);
	mtask_flag=1;
	pthread_exit(0);
}

void *motor_thread_rotate(void *arg){
	int *cmd=(int*)arg;
	double angle = cmd[0]*PI/180;
	int dis = (int)(angle*MIRS_RADIUS);
	int time = cmd[1];
	int c_left, c_right;
	int speed_l, speed_r, x_l, x_r;
	int dir=1; // dirction flag
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	
	speed_l = (int)(-100*dis/(t_par*time));
	speed_r = (int)(100*dis/(t_par*time));
	if(abs(speed_l) > VMAX){
		if(speed_l > VMAX){ v_l = VMAX; v_r = -VMAX; }
		else{ v_l = -VMAX; v_r = VMAX; }
	}else{
		v_l = (char)speed_l;
		v_r = (char)speed_r;
	}

	if(v_l>0){dir=-1;}
	/*
	if(abs(v_l)<15){
		v_l=-15*dir;
		v_r=-15*dir;
	}
	*/

	v_lm = v_l; v_rm = v_r;	

	dis=abs(dis);

	pthread_mutex_lock(&mutex_motor);
//	motor_send_start_packet (fd1);
//	motor_send_start_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);

	c_left=0; c_right=0;
	v_lm=v_l; v_rm=v_r;

	printf("rotation distance [mm] = %d\n",dis);

	while(1){
		//pthread_testcancel();
		//printf("recv start\n");
		pthread_mutex_lock(&mutex_motor);
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		pthread_mutex_unlock(&mutex_motor);
		//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		//printf("end\n");		
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		//printf("puls\tl = %d, r = %d\n", c_left, c_right);
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		//if(v_l <= 0 || v_r <= 0) break;

		if(abs(x_l+dis*dir) > 50 || abs(x_r-dis*dir) > 50){
			if((x_l + x_r) > 10){
				v_lm=v_l-3; v_rm=v_r-3;
				pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				pthread_mutex_unlock(&mutex_motor);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else if((x_l + x_r) < -10){
				v_lm=v_l+3; v_rm=v_r+3;
				pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				pthread_mutex_unlock(&mutex_motor);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else{
				v_lm=v_l;
				v_rm=v_r;
				pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_l,Kp,Ki);
				motor_send_control_packet(fd2,v_r,Kp,Ki);
				pthread_mutex_unlock(&mutex_motor);
			}
			//printf("fist loop\n");
		}

		if(abs(x_l+dis*dir) < 50 && abs(x_r-dis*dir) < 50){
			//printf("second loop\n");
			//exit(0);
			motor_send_control_packet(fd1,-10*dir,Kp,Ki);
			motor_send_control_packet(fd2,10*dir,Kp,Ki);
			while(1){
				printf("recv start\n");
				pthread_mutex_lock(&mutex_motor);
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				pthread_mutex_unlock(&mutex_motor);
				printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
				printf("end\n");		
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
				printf("puls\tl = %d, r = %d\n", c_left, c_right);
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);

				if(abs(x_l+dis*dir) < 10 && abs(x_r-dis*dir) < 10){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
					break;
				}

				if(abs(x_l+dis*dir) < 20 && abs(x_r-dis*dir) < 20){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,-5*dir,Kp,Ki);
					motor_send_control_packet(fd2,5*dir,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
				}else if(abs(x_l+dis*dir) < 20 || abs(x_r-dis*dir) < 20){
					if(abs(x_l+dis*dir) < 20){
						pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd1,-5*dir,Kp,Ki);
						pthread_mutex_unlock(&mutex_motor);
					}else{
						pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd2,5*dir,Kp,Ki);
						pthread_mutex_unlock(&mutex_motor);
					}
				}

				if(abs(x_l) > abs(dis)+10 && abs(x_r) > abs(dis)+10){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,7*dir,Kp,Ki);
					motor_send_control_packet(fd2,-7*dir,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
				} else if(abs(x_l) > abs(dis)+10 || abs(x_r) > abs(dis)+10 ){
					if(abs(x_l) > abs(dis) + 10){
						pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd1,7*dir,Kp,Ki);
						pthread_mutex_unlock(&mutex_motor);
					}else{
						pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd2,-7*dir,Kp,Ki);
						pthread_mutex_unlock(&mutex_motor);
					}
				}

				printf("roop end\n");
				usleep(130*1000);
			}
			break;
		}
		usleep(130*1000);

	}

	if(motor_send_control_packet(fd1,v_l,Kp,Ki) < 0){fprintf(stderr, "error");}
	if(motor_send_control_packet(fd2,v_r,Kp,Ki) < 0){fprintf(stderr, "error");}
	pthread_mutex_lock(&mutex_motor);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	pthread_mutex_unlock(&mutex_motor);
	mtask_flag=1;
	pthread_exit(0);
}

void *motor_thread_circle(void *arg){
	int c_left,c_right;
	int *cmd=(int*)arg;
	int dis_l,dis_r,time;
	int speed_l, speed_r;
	int x_l,x_r;
	float cr,mr;
	float s_l,s_r;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	printf("thread in\n");
	
/*
	if(cmd[0]>0){
		s_l=(CIRCLE_RADIUS-MIRS_RADIUS)/CIRCLE_RADIUS;
		s_r=(CIRCLE_RADIUS+MIRS_RADIUS)/CIRCLE_RADIUS;
	}else{
		s_l=(CIRCLE_RADIUS+MIRS_RADIUS)/CIRCLE_RADIUS;
		s_r=(CIRCLE_RADIUS-MIRS_RADIUS)/CIRCLE_RADIUS;
	}
*/
	cr=CIRCLE_RADIUS;
	mr=MIRS_RADIUS;
	if(cmd[0]>0){
		s_l=(cr-mr)/cr;
		s_r=(cr+mr)/cr;
	}else{
		s_l=(cr+mr)/cr;
		s_r=(cr-mr)/cr;
	}
	printf("cr=%f, mr=%f, s_l=%f  s_r=%f\n",cr,mr,s_l,s_r);
	//if(s_l==0 || s_r==0){
	/*
		pthread_mutex_lock(&mutex_motor);
		motor_send_control_packet(fd1,0,Kp,Ki);
		motor_send_control_packet(fd2,0,Kp,Ki);
		motor_send_clear_packet(fd1);
		motor_send_clear_packet(fd2);
		pthread_mutex_unlock(&mutex_motor);
		pthread_exit(0);
		exit(0);
	*/
	//}

	dis_l=abs(cmd[0])*CIRCLE_RADIUS*PI/180*s_l;
	dis_r=abs(cmd[0])*CIRCLE_RADIUS*PI/180*s_r;
	time=cmd[1];
	
	speed_l=(int)(100*dis_l/(t_par*time));
	speed_r=(int)(100*dis_r/(t_par*time));
	
	if(abs(speed_l) > VMAX){
		if(speed_l < 0){ v_l=VMAX; v_r=VMAX; }
		else{ v_l = -VMAX; v_r = -VMAX; }
	}else{
		v_l = (char)speed_l;
		v_r = (char)speed_r;
	}
	//v_l = v_r = 30;
	v_lm = v_l; v_rm = v_r;	

	pthread_mutex_lock(&mutex_motor);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);
//	usleep(2000*1000);
	printf("end\n");
	c_left=0; c_right=0;
	while(1){
		//pthread_testcancel();
		//printf("recv start\n");
		pthread_mutex_lock(&mutex_motor);
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		pthread_mutex_unlock(&mutex_motor);
		//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		//printf("end\n");		
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		//printf("puls\tl = %d, r = %d\n", c_left, c_right);
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		if(x_r!=0 && s_l!=0){printf("ratio= %d\n", x_l/x_r*s_r/s_l);}
		//if(v_l <= 0 || v_r <= 0) break;

		if(abs(x_l-dis_l) > 100 || abs(x_r-dis_r) > 100){
			if((float)(x_l-dis_l)/s_l - (float)(x_r-dis_r)/s_r > 10){
				v_lm=v_l-3; v_rm=v_r+3;
				pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				pthread_mutex_unlock(&mutex_motor);
			}else if((float)(x_l-dis_l)/s_l - (float)(x_r-dis_r)/s_r < -10){
				v_lm=v_l+3; v_rm=v_r-3;
				pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				pthread_mutex_unlock(&mutex_motor);
			}else{
				pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_l,Kp,Ki);
				motor_send_control_packet(fd2,v_r,Kp,Ki);
				pthread_mutex_unlock(&mutex_motor);
			}
			printf("first loop\n");
		}

		if(abs(x_l-dis_l) < 100 || abs(x_r-dis_r) < 100){
			printf("second loop\n");
			pthread_mutex_lock(&mutex_motor);
			motor_send_control_packet(fd1,15*s_l,Kp,Ki);
			motor_send_control_packet(fd2,15*s_r,Kp,Ki);
			pthread_mutex_unlock(&mutex_motor);
			while(1){
				//printf("recv start\n");
				pthread_mutex_lock(&mutex_motor);
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				pthread_mutex_unlock(&mutex_motor);
				//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
				//printf("end\n");		
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
				//printf("puls\tl = %d, r = %d\n", c_left, c_right);
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);

				if(abs(x_l-dis_l) < 20 && abs(x_r-dis_r) < 20){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
					break;
				}
				if(abs(x_l-dis_l) < 50 || abs(x_r-dis_r) < 50){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,10*s_l,Kp,Ki);
					motor_send_control_packet(fd2,10*s_r,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
				}
				if(abs(x_l-dis_l) < 30 || abs(x_r-dis_r) < 30){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,5*s_l,Kp,Ki);
					motor_send_control_packet(fd2,5*s_r,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
				}
				if(abs(x_l) > abs(dis_l)+20){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,-7*s_l,Kp,Ki);
					motor_send_control_packet(fd2,-4*s_r,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
				}
				if(abs(x_r) > abs(dis_r)+20){
					pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,-4*s_l,Kp,Ki);
					motor_send_control_packet(fd2,-7*s_r,Kp,Ki);
					pthread_mutex_unlock(&mutex_motor);
				}

				printf("roop end\n");
				usleep(130*1000);
			}
			break;
		}
		usleep(130*1000);
	}
	
	pthread_mutex_lock(&mutex_motor);
	motor_send_control_packet(fd1,0,Kp,Ki) < 0;
	motor_send_control_packet(fd2,0,Kp,Ki) < 0;
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	pthread_mutex_unlock(&mutex_motor);
	mtask_flag=1;
	pthread_exit(0);
}

