#include <cv.h>
#include <highgui.h>
#include <cxcore.h>

#include "./include/ssdefine.h"
#include <stdio.h>

CvScalar seesaw,smooth;

int main(){
	
	FILE *fp1,*fp2;
	
	fp1=fopen("./info1.txt","a");
	fp2=fopen("./info2.txt","a");

	IplImage *seesawImage;
	IplImage *smoothImage;
	IplImage *hsvImage;
	IplImage *hsvImage2;
	IplImage *maskImage;
	IplImage *maskImage2;

	seesawImage=cvCreateImage(cvSize(SS_X,SS_Y),IPL_DEPTH_8U,3);
	smoothImage=cvCreateImage(cvSize(SS_X,SS_Y),IPL_DEPTH_8U,3);
	hsvImage=cvCreateImage(cvSize(SS_X,SS_Y),IPL_DEPTH_8U,3);
	hsvImage2=cvCreateImage(cvSize(SS_X,SS_Y),IPL_DEPTH_8U,3);
	maskImage=cvCreateImage(cvSize(SS_X,SS_Y),IPL_DEPTH_8U,1);
	maskImage2=cvCreateImage(cvSize(SS_X,SS_Y),IPL_DEPTH_8U,1);

	int x,y;
	int h,s,v;
	int ssarea=0,ssarea2=0;
	int ssflag=0;

	cvNamedWindow("seesaw",CV_WINDOW_AUTOSIZE);
	cvNamedWindow("smooth",CV_WINDOW_AUTOSIZE);
	cvNamedWindow("mask",CV_WINDOW_AUTOSIZE);
	cvNamedWindow("mask_s",CV_WINDOW_AUTOSIZE);

	//while(ssflag!=1){

	ssarea=0;

	img_update("./image/seesaw.jpg",SS_X,SS_Y);
	seesawImage=cvLoadImage("./image/seesaw.jpg",CV_LOAD_IMAGE_COLOR);

	cvSmooth(seesawImage,smoothImage,CV_GAUSSIAN,11,0,0,0);
	cvCvtColor(seesawImage,hsvImage,CV_BGR2HSV);
	cvCvtColor(smoothImage,hsvImage2,CV_BGR2HSV);

	for(x=0;x<hsvImage->width;x++){
		for(y=hsvImage->height/2;y<hsvImage->height;y++){
			cvSetReal2D(maskImage,y,x,0);
			seesaw=cvGet2D(hsvImage,y,x);
			
			h=seesaw.val[0];
			s=seesaw.val[1];
			v=seesaw.val[2];

			if(h<=H_MAX && h>=H_MIN){
				if(s<=S_MAX && s>=S_MIN){
					if(v<=V_MAX && v>=V_MIN){
						cvSetReal2D(maskImage,y,x,255);
						ssarea++;
			}
				}
					}
			
			fprintf(fp1,"[%d,%d]=(%d,%d,%d)\n",x,y,h,s,v);
			
			cvSetReal2D(maskImage2,y,x,0);
			smooth=cvGet2D(hsvImage2,y,x);
			
			h=smooth.val[0];
			s=smooth.val[1];
			v=smooth.val[2];

			if(h<=H_MAX && h>=H_MIN){
				if(s<=S_MAX && s>=S_MIN){
					if(v<=V_MAX && v>=V_MIN){
						cvSetReal2D(maskImage2,y,x,255);
						ssarea2++;
			}
				}
					}
			fprintf(fp2,"[%d,%d]=(%d,%d,%d)\n",x,y,h,s,v);

		}
	}

	/*seesaw=cvGet2D(hsvImage,SS_X/2,SS_Y/2);
		h=seesaw.val[0];
		s=seesaw.val[1];
		v=seesaw.val[2];
		printf("h=%d,s=%d,v=%d\n",h,s,v);*/

	printf("area=%d\n",ssarea);
	printf("area2=%d\n",ssarea2);
		
	cvShowImage("seesaw",seesawImage);
	cvShowImage("smooth",smoothImage);
	cvShowImage("mask",maskImage);
	cvShowImage("mask_s",maskImage2);
	if(cvWaitKey(10)==27)goto END;

	//}

	printf("detect seesaw!!!\n");

	cvWaitKey(0);

END:	
	cvReleaseImage(&seesawImage);
	cvReleaseImage(&smoothImage);
	cvReleaseImage(&hsvImage);
	cvReleaseImage(&maskImage);

	cvDestroyWindow("seesaw");
	cvDestroyWindow("smooth");
	cvDestroyWindow("mask");

	return 0;	
}
