#include "../include/GV.h"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <math.h>

#include <sys/io.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>

#include <pthread.h>

#include <termios.h>
#include <stdio.h>
#include <string.h>

#define DS_PORT "/dev/ttyS1"
#define BAU B19200

static struct termios oldtio,newtio;

static int fd5;

#define CN 6

void ini_ds(){

	char command[127];

	if((fd5=open( DS_PORT , O_RDWR | O_NOCTTY ))<0){
			fprintf(stderr,"couldn't open fd5 \n");
			return;
	}

	fcntl(fd5, F_SETFL, FASYNC);
	tcgetattr(fd5,&oldtio);

	bzero(&newtio, sizeof(newtio));
	newtio.c_cflag = BAU | CS8 | CLOCAL | CREAD;
	newtio.c_iflag = IGNPAR;
	newtio.c_oflag = 0;
	newtio.c_lflag = 0;	//非カノニカル
	newtio.c_cc[VTIME]    = 0;	//キャラクタ間タイマ無効
	newtio.c_cc[VMIN]     = CN;	//6文字読み込むまでブロック
 
	tcflush(fd5, TCIFLUSH);
	tcsetattr(fd5,TCSANOW,&newtio);

	sprintf(command,"* DM FB @21 w47_74_51_41 \r\n");

	write(fd5,command,strlen(command));
	
	return;

}

static fd_set rfds;
static struct timeval tv;

int ds_get(){

	int i,result=0,sisya=0,retang=0;
	
	char buf[127],command[50];
	char buf_temp;
	
	tcflush(fd5, TCIFLUSH);

	sprintf(command,"r@21 r2p\r\n");
	
	write(fd5,command,strlen(command));

	usleep(50000);
	
	read(fd5,&buf,CN);
	
	for(i=0;i<4;i++){
	
		switch(i){
		
		case 0:
			buf_temp=buf[1];
			break;
		case 1:
			buf_temp=buf[2];
			break;
		case 2:
			buf_temp=buf[4];
			break;
		case 3:
			buf_temp=buf[5];
			break;
		
		}
		
		if(buf_temp>=48 && buf_temp<=57)result+=(buf_temp-48)*pow(16,3-i); //'0'～'9'なら
   else if(buf_temp>=97 && buf_temp<=102)result+=(buf_temp-87)*pow(16,3-i);//'a'～'f'なら
		else{
			fprintf(stderr,"number encord error\n");
			return 9999;
		}
		
	}
	
	/*if(result>=0 && result<400)result+=0.125*result;
	else if(result>=400 && result<820)result+=0.07*result;
	else if(result>=820 && result<1329)result-=0.11*(result-400);
	else if(result>=1329 && result<1831)result-=0.1*(result-820);
	else if(result>=2250 && result<2280)result-=0.02*(result-1329);
	else if(result>=2280 && result<2673)result+=0.15*(result-2250);
	else if(result>=2673 && result<3156)result-=0.07*(result-2280);
	else if(result>=3156 && result<3600)result+=0.013*(result-2673);*/
	
	sisya=result/10;
	retang=sisya;
	sisya*=10;
	sisya=result-sisya;
	if(sisya>=5)retang++;
	if(retang==360)retang=0;
	
	return (retang);

}

void *ds_thread(){
	
	int temp,temp2,old=0,loop_cnt=0;
	
	ini_ds();
	usleep(DELAY_DS);
	
	ds_get();//なんか一回目はRAMに残った値を出力しちゃうみたいなんでとりあえずやっとく
	
	usleep(DELAY_DS);
	
	int stdang=ds_get();

	while(1){
	
		temp=ds_get();
		
		temp2=stdang-temp-360;
		
		if(temp2-old>180)loop_cnt--;
		else if(temp2-old<-180)loop_cnt++;
		
		mirs.angle_now=temp2+360*loop_cnt;
		
		old=temp2;
		
		usleep(DELAY_DS);
		
	
	}

}

