#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
//#include <termios.h>
#include <pthread.h>
//#include <sys/types.h>
//#include <sys/stat.h>
#include <fcntl.h>
#include "../include/func_extern.h"
#include "../include/mg3.h"
//#include "../main/control.h"
//#include "../main/pwm_enc.h"
#include "../include/motor.h"

extern int fd1, fd2;
//extern pthread_t motor_task;
//extern pthread_attr_t attr_motor;

int motor(char sel,int dis_or_deg,int time){
	int s=0;
	int dt[2];
	
	dt[0]=dis_or_deg; // distanece [mm]
	dt[1]=time; // time [msec]

	motor_send_start_packet (fd1);
	motor_send_start_packet (fd2);
	if(sel == 's'){
		printf("t start\n");
//		s=pthread_create(&motor_task, &attr_motor, motor_thread_straight, (void*)dt);
		motor_straight(dt);
	}else if(sel == 'r'){
//		s=pthread_create(&motor_task, &attr_motor, motor_thread_rotate, (void*)dt);
		motor_rotate(dt);
	}else if(sel == 'c'){
//		s=pthread_create(&motor_task, &attr_motor, motor_thread_circle, (void*)dt);
		motor_circle(dt);
	}else{
		printf("command_errer\n");
	}
	if( s != 0 ){ printf("motor_task create error\n"); }
//	pthread_join(motor_task, NULL);
	
	motor_send_stop_packet (fd1);
	motor_send_stop_packet (fd2);
	return 0;
}

int motor_stop(){
	motor_send_stop_packet (fd1);
	motor_send_stop_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
}
	
void motor_straight(void *arg){
	int c_left,c_right;
	int *cmd=(int*)arg;
	int dis,time;
	int speed_l, speed_r;
	int x_l,x_r;
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	printf("thread in\n");
	dis=cmd[0];
	time=cmd[1];
	
	speed_l=(int)(100*dis/(t_par*time));
	speed_r=(int)(100*dis/(t_par*time));
	
	if(abs(speed_l) > VMAX){
		if(speed_l < 0){ v_l=VMAX; v_r=VMAX; }
		else{ v_l = -VMAX; v_r = -VMAX; }
	}else{
		v_l = (char)speed_l;
		v_r = (char)speed_r;
	}
	v_lm = v_l; v_rm = v_r;	

	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	printf("send start\n");
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);

	usleep(130*1000);

	printf("end\n");
	c_left=0; c_right=0;
	while(1){
		//pthread_testcancel();
		printf("recv start\n");
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		printf("end\n");		
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		printf("puls\tl = %d, r = %d\n", c_left, c_right);
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		//if(v_l <= 0 || v_r <= 0) break;

		if(abs(x_l-dis) > 100 || abs(x_r-dis) > 100){
			if(x_l - x_r > 10){
				v_lm=v_l-5; v_rm=v_r+5;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
			}else if(x_r - x_l > 10){
				v_lm=v_l+5; v_rm=v_r-5;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
			}else{
				motor_send_control_packet(fd1,v_l,Kp,Ki);
				motor_send_control_packet(fd2,v_r,Kp,Ki);
			}
		}

		if(abs(x_l-dis) < 100 || abs(x_r-dis) < 100){
			motor_send_control_packet(fd1,v_l/2,Kp,Ki);
			motor_send_control_packet(fd2,v_r/2,Kp,Ki);
			while(1){
				printf("recv start\n");
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
				printf("end\n");		
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
				printf("puls\tl = %d, r = %d\n", c_left, c_right);
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);

				if(abs(x_l-dis) < 20 && abs(x_r-dis) < 20){
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
					break;
				}
				if(abs(x_l-dis) < 50 || abs(x_r-dis) < 50){
					motor_send_control_packet(fd1,v_l/4,Kp,Ki);
					motor_send_control_packet(fd2,v_r/4,Kp,Ki);
				}
				if(abs(x_l) > abs(dis)+20){
					motor_send_control_packet(fd1,-v_l/4,Kp,Ki);
					//motor_send_control_packet(fd2,0,Kp,Ki);
				}
				if(abs(x_r) > abs(dis)+20){
					//motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,-v_r/4,Kp,Ki);
				}

				printf("roop end\n");
				usleep(130*1000);
			}
			break;
		}
		usleep(130*1000);
	}
	
	motor_send_control_packet(fd1,0,Kp,Ki);
	motor_send_control_packet(fd2,0,Kp,Ki);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	return 0;
}

void motor_rotate(void *arg){
	int *cmd=(int*)arg;
	double angle = cmd[0]*PI/180;
	int dis = (int)(angle*MIRS_RADIUS);
	int time = cmd[1];
	int c_left, c_right;
	int speed_l, speed_r, x_l, x_r;
	int dir=1; // dirction flag
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	
	speed_l = (int)(-100*dis/(t_par*time));
	speed_r = (int)(100*dis/(t_par*time));
	if(abs(speed_l) > VMAX){
		if(speed_l > VMAX){ v_l = VMAX; v_r = -VMAX; }
		else{ v_l = -VMAX; v_r = VMAX; }
	}else{
		v_l = (char)speed_l;
		v_r = (char)speed_r;
	}

	if(v_l>0){dir=-1;}
	/*
	if(abs(v_l)<15){
		v_l=-15*dir;
		v_r=-15*dir;
	}
	*/

	v_lm = v_l; v_rm = v_r;	

	dis=abs(dis);

	pthread_mutex_lock(&mutex_motor);
//	motor_send_start_packet (fd1);
//	motor_send_start_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	usleep(130000);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);
	pthread_mutex_unlock(&mutex_motor);
	usleep(130*1000);
	c_left=0; c_right=0;
	v_lm=v_l; v_rm=v_r;

	printf("rotation distance [mm] = %d\n",dis);

	while(1){
		//pthread_testcancel();
		//printf("recv start\n");
		//pthread_mutex_lock(&mutex_motor);
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		//pthread_mutex_unlock(&mutex_motor);
		//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		//printf("end\n");		
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		//printf("puls\tl = %d, r = %d\n", c_left, c_right);
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
	//	printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		//if(v_l <= 0 || v_r <= 0) break;

		if(abs(x_l+dis*dir) > 50 || abs(x_r-dis*dir) > 50){
			if((x_l + x_r) > 10){
				v_lm=v_l-3; v_rm=v_r-3;
				//pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				//pthread_mutex_unlock(&mutex_motor);
	//			printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else if((x_l + x_r) < -10){
				v_lm=v_l+3; v_rm=v_r+3;
				//pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				//pthread_mutex_unlock(&mutex_motor);
	//			printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else{
				v_lm=v_l;
				v_rm=v_r;
				//pthread_mutex_lock(&mutex_motor);
				motor_send_control_packet(fd1,v_l,Kp,Ki);
				motor_send_control_packet(fd2,v_r,Kp,Ki);
				//pthread_mutex_unlock(&mutex_motor);
			}
			//printf("fist loop\n");
		}

		if(abs(x_l+dis*dir) < 50 && abs(x_r-dis*dir) < 50){
			//printf("second loop\n");
			//exit(0);
			motor_send_control_packet(fd1,-10*dir,Kp,Ki);
			motor_send_control_packet(fd2,10*dir,Kp,Ki);
			while(1){
	//			printf("recv start\n");
				//pthread_mutex_lock(&mutex_motor);
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				//pthread_mutex_unlock(&mutex_motor);
	//			printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
	//			printf("end\n");		
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
	//			printf("puls\tl = %d, r = %d\n", c_left, c_right);
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
	//			printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);

				if(abs(x_l+dis*dir) < 10 && abs(x_r-dis*dir) < 10){
					//pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
					//pthread_mutex_unlock(&mutex_motor);
					break;
				}

				if(abs(x_l+dis*dir) < 20 && abs(x_r-dis*dir) < 20){
					//pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,-5*dir,Kp,Ki);
					motor_send_control_packet(fd2,5*dir,Kp,Ki);
					//pthread_mutex_unlock(&mutex_motor);
				}else if(abs(x_l+dis*dir) < 20 || abs(x_r-dis*dir) < 20){
					if(abs(x_l+dis*dir) < 20){
						//pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd1,-5*dir,Kp,Ki);
						//pthread_mutex_unlock(&mutex_motor);
					}else{
						//pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd2,5*dir,Kp,Ki);
						//pthread_mutex_unlock(&mutex_motor);
					}
				}

				if(abs(x_l) > abs(dis)+10 && abs(x_r) > abs(dis)+10){
					//pthread_mutex_lock(&mutex_motor);
					motor_send_control_packet(fd1,7*dir,Kp,Ki);
					motor_send_control_packet(fd2,-7*dir,Kp,Ki);
					//pthread_mutex_unlock(&mutex_motor);
				} else if(abs(x_l) > abs(dis)+10 || abs(x_r) > abs(dis)+10 ){
					if(abs(x_l) > abs(dis) + 10){
						//pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd1,7*dir,Kp,Ki);
						//pthread_mutex_unlock(&mutex_motor);
					}else{
						//pthread_mutex_lock(&mutex_motor);
						motor_send_control_packet(fd2,-7*dir,Kp,Ki);
						//pthread_mutex_unlock(&mutex_motor);
					}
				}

	//			printf("roop end\n");
				usleep(130*1000);
			}
			break;
		}
		usleep(130*1000);

	}

	if(motor_send_control_packet(fd1,0,Kp,Ki) < 0){fprintf(stderr, "error");}
	if(motor_send_control_packet(fd2,0,Kp,Ki) < 0){fprintf(stderr, "error");}
	//pthread_mutex_lock(&mutex_motor);
	usleep(130000);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	usleep(130000);
	//pthread_mutex_unlock(&mutex_motor);
	mtask_flag=1;

	return 0;
}

void motor_circle(void *arg){
	int *cmd=(int*)arg;
	double angle = cmd[0]*PI/180;
	int dis = (int)(angle*MIRS_RADIUS);
	int time = cmd[1];
	int c_left, c_right;
	int speed_l, speed_r, x_l, x_r;
	int dir=1; // dirction flag
	char v_l, v_r, v_lm, v_rm;
	MotorInfo m_info_l, m_info_r;
	
	speed_l = (int)(-100*dis/(t_par*time));
	speed_r = (int)(100*dis/(t_par*time));
	if(abs(speed_l) > VMAX){
		if(speed_l > VMAX){ v_l = VMAX; v_r = -VMAX; }
		else{ v_l = -VMAX; v_r = VMAX; }
	}else{
		v_l = (char)speed_l;
		v_r = (char)speed_r;
	}

	if(v_l>0){dir=-1;}
	/*
	if(abs(v_l)<15){
		v_l=-15*dir;
		v_r=-15*dir;
	}
	*/

	v_lm = v_l; v_rm = v_r;	

	dis=abs(dis);

//	motor_send_start_packet (fd1);
//	motor_send_start_packet (fd2);
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	motor_send_control_packet(fd1,v_l,Kp,Ki);
	motor_send_control_packet(fd2,v_r,Kp,Ki);

	c_left=0; c_right=0;
	v_lm=v_l; v_rm=v_r;

	printf("rotation distance [mm] = %d\n",dis);

	while(1){
		//pthread_testcancel();
		//printf("recv start\n");
		motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
		motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
		//printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
		//printf("end\n");		
		c_left=m_info_l.puls;
		c_right=m_info_r.puls;
		//printf("puls\tl = %d, r = %d\n", c_left, c_right);
		x_l=(int)(c_left*t_par);
		x_r=(int)(c_right*t_par);
		printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);
		//if(v_l <= 0 || v_r <= 0) break;

		if(abs(x_l+dis*dir) > 50 || abs(x_r-dis*dir) > 50){
			if((x_l + x_r) > 10){
				v_lm=v_l-3; v_rm=v_r-3;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else if((x_l + x_r) < -10){
				v_lm=v_l+3; v_rm=v_r+3;
				motor_send_control_packet(fd1,v_lm,Kp,Ki);
				motor_send_control_packet(fd2,v_rm,Kp,Ki);
				printf("v_lm = %d, v_rm = %d \n", v_lm, v_rm);
			}else{
				v_lm=v_l;
				v_rm=v_r;
				motor_send_control_packet(fd1,v_l,Kp,Ki);
				motor_send_control_packet(fd2,v_r,Kp,Ki);
			}
			//printf("fist loop\n");
		}

		if(abs(x_l+dis*dir) < 50 && abs(x_r-dis*dir) < 50){
			//printf("second loop\n");
			//exit(0);
			motor_send_control_packet(fd1,-10*dir,Kp,Ki);
			motor_send_control_packet(fd2,10*dir,Kp,Ki);
			while(1){
				printf("recv start\n");
				motor_recv_status_packet(fd1, &(m_info_l.speed), &(m_info_l.pwm), &(m_info_l.puls));
				motor_recv_status_packet(fd2, &(m_info_r.speed), &(m_info_r.pwm), &(m_info_r.puls));
				printf("puls\tl = %ld, r = %ld\n", m_info_l.puls, m_info_r.puls);
				printf("end\n");		
				c_left=m_info_l.puls;
				c_right=m_info_r.puls;
				printf("puls\tl = %d, r = %d\n", c_left, c_right);
				x_l=(int)(c_left*t_par);
				x_r=(int)(c_right*t_par);
				printf("vl = %d, vr = %d, xl = %d, xr = %d\n", v_l, v_r, x_l, x_r);

				if(abs(x_l+dis*dir) < 10 && abs(x_r-dis*dir) < 10){
					motor_send_control_packet(fd1,0,Kp,Ki);
					motor_send_control_packet(fd2,0,Kp,Ki);
					break;
				}

				if(abs(x_l+dis*dir) < 20 && abs(x_r-dis*dir) < 20){
					motor_send_control_packet(fd1,-5*dir,Kp,Ki);
					motor_send_control_packet(fd2,5*dir,Kp,Ki);
				}else if(abs(x_l+dis*dir) < 20 || abs(x_r-dis*dir) < 20){
					if(abs(x_l+dis*dir) < 20){
						motor_send_control_packet(fd1,-5*dir,Kp,Ki);
					}else{
						motor_send_control_packet(fd2,5*dir,Kp,Ki);
					}
				}

				if(abs(x_l) > abs(dis)+10 && abs(x_r) > abs(dis)+10){
					motor_send_control_packet(fd1,7*dir,Kp,Ki);
					motor_send_control_packet(fd2,-7*dir,Kp,Ki);
				} else if(abs(x_l) > abs(dis)+10 || abs(x_r) > abs(dis)+10 ){
					if(abs(x_l) > abs(dis) + 10){
						motor_send_control_packet(fd1,7*dir,Kp,Ki);
					}else{
						motor_send_control_packet(fd2,-7*dir,Kp,Ki);
					}
				}

				printf("roop end\n");
				usleep(130*1000);
			}
			break;
		}
		usleep(130*1000);

	}

	if(motor_send_control_packet(fd1,v_l,Kp,Ki) < 0){fprintf(stderr, "error");}
	if(motor_send_control_packet(fd2,v_r,Kp,Ki) < 0){fprintf(stderr, "error");}
	motor_send_clear_packet(fd1);
	motor_send_clear_packet(fd2);
	mtask_flag=1;
	return 0;
}

