/********************************************************/
/*                                                      */
/*      処理内容：                                      */
/*      キー入力されたらすぐ表示、                      */
/*      入力されなくても処理待ちしない                  */
/*                                                      */
/*      参考(一部引用)                                  */
/*      http://questionbox.jp.msn.com/qa717149.html     */
/********************************************************/
#include <stdio.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <unistd.h>
#include <string.h>

#include "../include/GV.h"

#define SPD 127

int main(void)
{

int temp=0;

    	ini();//初期設定関数
	ini_onoff_thread();//onoffセンサー監視スレッド
	ini_thread();//センサー&key監視スレッド

sensor.ussflag1=1;
sensor.ussflag2=1;
sensor.ussflag3=1;

motor_forward(100);
usleep(200000);
motor_stop2();

        char in_char = 0; /* 入力されたキーを保持 */
        char read_byt = 0; /* 読み込んだバイト数 */
        struct termio tty_backup; /* 変更前の設定を保持 */
        struct termio tty_change; /* 変更後の設定を保持 */


        /* 最初に現在の設定を退避します */
        ioctl(0, TCGETA, &tty_backup);
        tty_change = tty_backup;


        /* 設定を変更し、反映させます */
        tty_change.c_lflag &= ~(ECHO | ICANON); /* エコーを止め、RAW モードへ変更 */
        tty_change.c_cc[VMIN] = 0;
        tty_change.c_cc[VTIME] = 1;
        ioctl(0, TCSETAF, &tty_change);

		memset(&flag,0,sizeof(flag));

        /*      文字入力                */
        while(1){

	temp=(int)sensor.ts1;
	
	if(temp==49)motor_stop2();
\

	printf("ts1=%c\t ts2=%c\t ts3=%c\t ws1=%c\t ws2=%c\n",sensor.ts1,sensor.ts2,sensor.ts3,sensor.ws1,sensor.ws2);

	printf("ws3=%c  irs=%c  ds=%c\n",sensor.ws3,sensor.irs,sensor.ds);
	printf("uss1=%d  uss2=%d  uss3=%d\n\n\n",sensor.uss1,sensor.uss2,sensor.uss3);


                read_byt = read(0, &in_char, 1);

			if(read_byt==-1){
				motor_stop2();
				ioctl(0, TCSETAF, &tty_backup);
				return -1;
			}

                switch(in_char){
                	case    -1:
                        ioctl(0, TCSETAF, &tty_backup);
                        return -1;
                case 65:
                      if(flag.forward==0)motor_forward(SPD);
			   memset(&flag,0,sizeof(flag));
			   flag.forward=1;
                        break;
		   case 66:
			   if(flag.back==0)motor_back(SPD);
			   memset(&flag,0,sizeof(flag));
			   flag.back=1;
			     break;
		   case 67:
			 if(flag.rotation_r==0)motor_rotation(SPD,RIGHT);
			   memset(&flag,0,sizeof(flag));
			   flag.rotation_r=1;
			     break;
		   case 68:
			 if(flag.rotation_l==0)motor_rotation(SPD,LEFT);
			   memset(&flag,0,sizeof(flag));
			   flag.rotation_l=1;
			     break;
		   case 'e':
			  ioctl(0, TCSETAF, &tty_backup);
			   motor_stop2();
			   return 0;
			   break;
                default:
                        if(flag.stop==0)motor_stop2();
			     memset(&flag,0,sizeof(flag));
			     flag.stop=1;
				break;
                }

        }

        /* 退避していた設定に戻す */
        ioctl(0, TCSETAF, &tty_backup);

        /* 正常終了 */
        return 0;
}
